//
//  CalculatorView.m
//  Calcolatrice
//
//  Created by valvoline on 10/26/09.
//  Copyright 2009 __MyCompanyName__. All rights reserved.
//

#import "CalculatorView.h"


@implementation CalculatorView

- (id)initWithFrame:(CGRect)frame {
    if (self = [super initWithFrame:frame]) {
		[self setBackgroundColor:[UIColor grayColor]];
		for(int i=0;i<2;i++) {
			for(int j=0;j<5;j++) {
				UIButton *tempButton = [UIButton buttonWithType:UIButtonTypeRoundedRect];
				[tempButton setFrame:CGRectMake(j*64, (i*64)+100, 60, 60)];
				[tempButton setTitle:[NSString stringWithFormat:@"%d", j+(i*5)]  forState:UIControlStateNormal];
				[tempButton addTarget:self action:@selector(numberPressed:) forControlEvents:UIControlEventTouchUpInside];
				[self addSubview:tempButton];
			}
		}
		operazioni = [[NSMutableArray alloc] init];
		[operazioni addObject:[NSString stringWithString:@"+"]]; //0
		[operazioni addObject:[NSString stringWithString:@"-"]]; //1
		[operazioni addObject:[NSString stringWithString:@"*"]]; //2
		[operazioni addObject:[NSString stringWithString:@"/"]]; //3
		[operazioni addObject:[NSString stringWithString:@"="]]; //4
		for(int j=0;j<5;j++) {
			UIButton *tempButton = [UIButton buttonWithType:UIButtonTypeRoundedRect];
			[tempButton setFrame:CGRectMake(j*64, (2*64)+100, 60, 60)];
			[tempButton setTitle:[operazioni objectAtIndex:j] forState:UIControlStateNormal];
			[tempButton addTarget:self action:@selector(operationPressed:) forControlEvents:UIControlEventTouchUpInside];
			[self addSubview:tempButton];
		}
		myDiplay = [[UILabel alloc] initWithFrame:CGRectMake(5, 20, 310, 60)];
		[myDiplay setBackgroundColor:[UIColor lightGrayColor]];
		[myDiplay setTextColor:[UIColor blackColor]];
		[myDiplay setText:[NSString stringWithString:@"0"]];
		[myDiplay setTextAlignment:UITextAlignmentRight];
		[self addSubview:myDiplay];
		[myDiplay release];
	}
    return self;
}

-(void)numberPressed:(id)sender {
	UIButton *tmp = sender;
	if([myDiplay.text isEqualToString:@"0"]) {
		myDiplay.text = [NSString stringWithFormat:@"%@", tmp.currentTitle];
	} else {
		myDiplay.text = [NSString stringWithFormat:@"%@%@", myDiplay.text, tmp.currentTitle];
	}
}

-(void) operationPressed:(id)sender {
	UIButton *tmp = sender;
	if([tmp.currentTitle isEqualToString:@"="]) {
		switch (selectedOperation) {
			case 0:
				resultValue += [myDiplay.text intValue];
				break;
			case 1:
				resultValue -= [myDiplay.text intValue];
				break;
			case 2:
				resultValue *= [myDiplay.text intValue];
				break;
			case 3:
				resultValue /= [myDiplay.text intValue];
				break;
		}
		myDiplay.text = [NSString stringWithFormat:@"%d", resultValue];
		selectedOperation = 4;
	} else {
		for(int i=0;i<[operazioni count];i++) {
			if([tmp.currentTitle isEqualToString:[operazioni objectAtIndex:i]]) {
				selectedOperation = i;
				resultValue = [myDiplay.text intValue];
				myDiplay.text = [NSString stringWithString:@"0"];
				break;
			}
		}
	}
}

- (void)dealloc {
	[operazioni release];
    [super dealloc];
}


@end
